--[[
	ChatLootValue: A chat message loot value addon.
	Copyright (c) 2011 Cyprias <Cyprias@gmail.com>
	All Rights Reserved.
]]

--[[
	Pricing system stolen from LilSparky's Workshop.
	http://www.wowace.com/addons/lil-sparkys-workshop/
]]

local folder, core = ...
local L = core.L or LibStub("AceLocale-3.0"):GetLocale(folder, true)


local _G = _G
local math_floor = math.floor

-- AuctionLite support

do

	local function AuctionPrice(itemID) -- AuctionLite version
		if not itemID then
			return nil
		end

		local hist = _G.AuctionLite:GetHistoricalPriceById(itemID, 0)

		local price, count

		if hist then
			price, count = math_floor(hist.price), math_floor(hist.items)
		end

		return price, count
--		return AuctionLite:GetAuctionValue(itemID)
	end

	local function OnScanComplete()
		core:FlushPriceData()
	end

	local function Init()
		core:RegisterAlgorithm(L["AuctionLite"], AuctionPrice)
--		TODO: figure out when to flush the auction data
	end


	local function Test(index)
		if _G.AuctionLite then
			return true
		end

		return false
	end

	core:RegisterPricingSupport("AuctionLite", Test, Init)
end

