--[[
	ChatLootValue: A chat message loot value addon.
	Copyright (c) 2011 Cyprias <Cyprias@gmail.com>
	All Rights Reserved.
]]

--[[
	Pricing system stolen from LilSparky's Workshop.
	http://www.wowace.com/addons/lil-sparkys-workshop/
]]

local folder, core = ...

local L = core.L or LibStub("AceLocale-3.0"):GetLocale(folder, true)

local ipairs = ipairs
local _G = _G
local GetAddOnInfo = GetAddOnInfo
local EnableAddOn = EnableAddOn

-- auctioneer support

do
	local noBuyout = 100 * 100 * 100 --100g
	local function AuctionPriceMinBuyout(link)
		if not link then
			return nil
		end

		local imgSeen, image, matchBid, matchBuy, lowBid, lowBuy, aveBuy, aSeen = _G.AucAdvanced.Modules.Util.SimpleAuction.Private.GetItems(link)

		if imgSeen <= 0 then
			local market = _G.AucAdvanced.API.GetMarketValue(link) or noBuyout
			
			return market * 2, 0
		end

		return lowBuy, imgSeen
	end

	--[[
	local function BestMatch(itemID)
		if not itemID then
			return nil
		end
		return _G.AucAdvanced.API.GetBestMatch(itemID, "market") or 0
	end
	]]

	local function Init()
		core:RegisterAlgorithm(L["Auctioneer Market"], _G.AucAdvanced.API.GetMarketValue)



		local engines = _G.AucAdvanced.GetAllModules(nil, "Stat")

		for pos, engineLib in ipairs(engines) do
			local name = engineLib.GetName()

			core:RegisterAlgorithm(L["Auctioneer"].." "..name, function(link)
				return _G.AucAdvanced.API.GetAlgorithmValue(name, link)
			end)
		end

		if _G.AucAdvanced.Modules.Util.SimpleAuction then
			core:RegisterAlgorithm(L["Auctioneer Min Buyout"], AuctionPriceMinBuyout)
		end
		
		if _G.AucAdvanced.Modules.Util.Appraiser then
			-- Auc-ScanData gets loaded when GetPrice is called, but not if the checkbox is disabled. Lets just make sure the checkbox is enabled. :)
			local scanData = "Auc-ScanData"
			local _, _, _, enabled = GetAddOnInfo(scanData)
			if not enabled then
				EnableAddOn(scanData)
			end
		
			core:RegisterAlgorithm(L["Auctioneer Appraiser"], _G.AucAdvanced.Modules.Util.Appraiser.GetPrice)
--~ 			core:RegisterAlgorithm("Auctioneer Appraiser", function() return 0 end) --testing
		end
		
		--[[
		if _G.AucAdvanced.API.GetBestMatch then
			core:RegisterAlgorithm("Auctioneer BestMatch", BestMatch)
		end
		]]
		
		local lib,parent,private = _G.AucAdvanced.NewModule("Util", "CLVPriceRescan")
		function lib.Processor(callbackType)
			if (callbackType == "scanstats") then
				core:FlushPriceData()
			end
		end
	end


	local function Test(index)
		if _G.AucAdvanced and _G.AucAdvanced.Version then
			return true
		end

		return false
	end

	core:RegisterPricingSupport("Auctioneer", Test, Init)
	
end
