--[[
	ChatLootValue: A chat message loot value addon.
	Copyright (c) 2011 Cyprias <Cyprias@gmail.com>
	All Rights Reserved.
]]

--[[
	Pricing system stolen from LilSparky's Workshop.
	http://www.wowace.com/addons/lil-sparkys-workshop/
]]

local folder, core = ...

local L = core.L or LibStub("AceLocale-3.0"):GetLocale(folder, true)

local pairs = pairs
local GetItemInfo = GetItemInfo


do
	local cacheName = L.prevPriceAlgorithm --"Previous login price"
	local vendorName = "VendorValue"
	
	local function tableCount(tbl)
		local count = 0
		for a, b in pairs(tbl) do 
			count = count + 1
		end
		return count
	end	
	
	local function VendorValue(itemID)
		local _, _, _, _, _, _, _, _, _, _, vendorPrice = GetItemInfo(itemID)
		return vendorPrice
	end
	
	local function saveValues()
		if core.db.profile.pricingAlgorithm ~= cacheName then
			if tableCount(core.auctionPrice) > 0 then
--~ 				core.db.factionrealm.cachedPrices = {} --reset
				
				for itemID, price in pairs(core.auctionPrice) do 
					if price ~= VendorValue(itemID) then
						core.db.factionrealm.cachedPrices[itemID] = price
					end
				end
			end
		end
	end
	
	local prev_Logout = Logout
	Logout = function(...)
		saveValues()
		prev_Logout()
	end
	
	local function getCachedPrice(itemID)
		if not itemID then
			return nil
		end
		return core.db.factionrealm.cachedPrices and core.db.factionrealm.cachedPrices[itemID] or nil
	end
	
	local function Init()
		core:RegisterAlgorithm(cacheName, getCachedPrice)
	end

	
	local function Test(index)
		if core.db.factionrealm.cachedPrices then
			return true
		end

		return false
	end
	
	core:RegisterPricingSupport("Cached Price", Test, Init)
end